//
//  MyChatContentView.swift
//  Sailassist
//
//  Created by Mamoru Sugita on 2023/11/08.
//

import SwiftUI

struct MyChatContentView: View {
    var message : ChatMessage
    var body: some View {
        HStack {
            Spacer()
            VStack(alignment: .trailing, spacing: 6) {
                Group {
                    if message.message.contains("https://") {   //TODO: stampIdが0
                        AsyncImage(url: URL(string: message.message)) { phase in
                            if let image = phase.image {
                                image
                                    .resizable(resizingMode: .stretch)
                                    .aspectRatio(contentMode: .fit)
                                    .frame(width: 250)
                            } else if phase.error != nil {
                                Color.gray.opacity(0.2)
                                    .overlay(Image(systemName: "rectangle.slash"))
                            } else {
                                Color.gray.opacity(0.2)
                                ProgressView()
                            }
                        }
                        .cornerRadius(16)
                        .frame(height: 250)
                    } else {
                        Text(message.message)
                            .font(FontStyle.DefaultText.font)
                            .foregroundColor(ColorSet.BodyChat.color)
                            .padding(15)
                            .background(ColorSet.ChatBaloon.color)
                            .cornerRadius(10, corners: [.tl, .tr, .br])
                    }
                }
                
                HStack(spacing: 5){
                    //既読マーク
                    Text(DateTextLib.ISO86012FormatText(message.time, format: "yyyy/MM/dd HH:mm", errFormat: ""))
                        .padding(.trailing, 8)
                    
                    let viewerCnt = viewerCnt()

                    Image("chat_company")
                        .resizable()
                        .scaledToFit()
                        .frame(width: 12, height: 12)
                        .padding(.trailing, 4)
                    
                    Text(String(viewerCnt.0))

                    Image("chat_ship")
                        .resizable()
                        .scaledToFit()
                        .frame(width: 12, height: 12)
                        .padding(.trailing, 4)

                    Text(String(viewerCnt.1))
                }
                .font(FontStyle.DateText.font)
                .foregroundColor(ColorSet.BodyDescriptiion.color)
            }
            .padding(.trailing, 20)
        }
        .padding(.leading, 80)
    }

    func viewerCnt() -> (Int, Int) {
        var shipViewer = 0
        var companyViewr = 0
        for viewer in message.viewer {
            if viewer.location == 1 {
                companyViewr += 1
            } else {
                shipViewer += 1
            }
        }
        return (shipViewer, companyViewr)
    }
}

#Preview {
    MyChatContentView(message: ChatMessage(
        shipId: 10000003,
        messageId: "92c2dfb5-f5ed-4943-98a3-9848d7f9a962",
        type: 0,
        time: "2023-10-06T01:51:01.872Z",
        location: 1,
        from: "はだだ",
        fromId: "487420489",
        message: "999",
        stampId: 0,
        viewer: [
            Viewer(
                time: "2023-10-06T01:51:12.973Z",
                location: 1,
                id: ""),
            Viewer(
                time: "2023-10-06T01:51:12.973Z",
                location: 2,
                id: "")
        ]
    ))
}
